/* MULTI1_3.CPP - yksinkertainen moniperint */
#include <stdio.h>

class cPiste {
  int x,y;
public:
  cPiste(int ix=0, int iy=0) { x = ix; y = iy; printf("R: cPiste %d\n",x);}
  void tulosta(int n=0) const { printf("(%d,%d)",x,y); if (n) printf("\n"); }
  ~cPiste() { printf("H: cPiste %d\n",x); }
};

class suorakulmio:public cPiste { // Vasen ylkulma
  cPiste oa;                      // Oikea alakulma
public:
  suorakulmio(int ix1=0,int iy1=0,int ix2=1, int iy2=1):
    cPiste(ix1,iy1) ,oa(ix2,iy2){
    printf("R: suorakulmio\n");
  }
  void tulosta(int n=0) const {
    cPiste::tulosta(0); printf("-"); oa.tulosta(n);
  }
  ~suorakulmio() { printf("H: suorakulmio\n"); }
};

int main(void)
{
  cPiste p(2,4); suorakulmio s(3,1,4,5);
  p.tulosta(1);
  s.tulosta(1);
  return 0;
}