/* MULTI2.CPP - oikea moniperint */
#include <stdio.h>

class cAsunto {
  int huoneita;
public:
  cAsunto(int ih=1) : huoneita(ih) {}
  void tulosta() const { printf("Huoneita: %d",huoneita); }
};


class cLaiva {
  double pituus;
public:
  cLaiva(double ipit=10.0) : pituus(ipit) {}
  void tulosta() const { printf("Pituus: %3.1lf m",pituus); }
};


class cAsuntolaiva : public cAsunto, public cLaiva {
public:
  cAsuntolaiva(int ih=1,double ipit=5.0) : cAsunto(ih) , cLaiva(ipit)  {}
  void tulosta() const {
    cAsunto::tulosta(); printf(" "); cLaiva::tulosta();
  }
};

int main(void)
{
  cAsuntolaiva koti(2,5.8);
  koti.tulosta(); printf("\n");
  return 0;
}