/* RETREF.CPP - referenssin palauttaminen, "turva"taulukko */
#include <stdio.h>

class cTaulukko {
  int *t;
  int koko;
  int laiton;
public:
  cTaulukko(int k);
  ~cTaulukko() { if (koko) delete [] t; }

  int get(int i) const {
    if ( ( i < 0 ) || ( koko <= i ) ) return laiton;
    return t[i];
  }

  int &put(int i) {
    if ( ( i < 0 ) || ( koko <= i ) ) {
      printf("Laiton taulukon indeksi %d!\n",i);
      return laiton;
    }
    return t[i]; // Palautetaan viittaus t[i]:hin!

  }

  void tulosta() const;

};


void cTaulukko::tulosta() const {
  for (int i=0; i<koko; i++) printf("%5d",t[i]);
  printf("\n");
}

cTaulukko::cTaulukko(int k)
{
  koko = 0; laiton = 0;
  if ( k <= 0 ) return;
  t = new int[k];
  if ( !t ) return;
  koko = k;
  for (int i=0; i<=koko; i++) t[i] = 0;
}


int main(void)
{
  cTaulukko a(5);
  a.tulosta();
  a.put(2) = 5;       // HUOM!  Muoto a.put(2,5) olisi parempi!
  a.put(4) = 3;
  a.tulosta();
  a.put(9) = 7;
  a.tulosta();

  return 0;
}
