/* STRING2.CPP */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

class jono{
  char *s;
  int max_pit;
  int pit;
public:

  jono(char *p) {   /* Rakentaja jos alustus merkkijonolla */
    max_pit = pit = strlen(p);
    s = new char[pit+1];
    if ( !s ) pit = max_pit = 0;
    else { strcpy(s,p); max_pit = pit; }
  }

  jono(int l=255) { /* Rakentaja jos kutsu kokonaisluvulla */
    pit = 0;
    max_pit = l;
    s = new char[max_pit+1];
    if ( !s ) max_pit = 0;
  }

  ~jono() {         /* Hvitys aina merkkijonon poisto     */
    delete s; pit = max_pit = 0;
  }


  int pituus() { return pit; }

  char kirjain(int i=0) { if (i<pit) return s[i]; return '#'; }

  int sijoita(char *p) {
    strncpy(s,p,max_pit); s[max_pit]=0;
    return pit = strlen(s);
  }

  void tulosta(char *fmt) { if ( pit > 0 ) printf(fmt,s); }

};


int main(void)
{
  jono kissa("Kissa"),kana(4);
  kana.sijoita("Kana");
  kissa.tulosta("%s\n");
  kana.tulosta("%s\n");
  kissa.sijoita("Muuttuhaukka");
  kissa.tulosta("%s\n");
  return 0;
}