/* STDSET.CPP */
// Esimerkki std:n set-luokan kytst, BC 5.00
#include <iostream.h>
#include <set>

typedef std::set<char,std::less<char> > cSet;
// Jos esiteltisiin std::multiset, tulisi mys monikert. esiintymi
// Jos esiteltisiin greater<char>  tulisi laskeva jrjestys

#define VIIVA "------------------------------------------------------------\n"
/****************************************************************************/
int main(void)
{
  cout << VIIVA;

  cSet lc;
  lc.insert('a'); lc.insert('b'); lc.insert('c'); lc.insert('d');
  lc.insert('k'); lc.insert('i'); lc.insert('f'); lc.insert('e');
  lc.insert('a');  // Ei en lisnny, koska jo on joukossa

  cSet::iterator lci;

  for (lci=lc.begin(); lci != lc.end(); lci++)
    cout << *lci << " ";        // a b c d e f i k
  cout << "\n" << VIIVA;

  lci = lc.find('d');

  cSet lc2(lci,lc.end());
  for (lci=lc2.begin(); lci != lc2.end(); lci++)
    cout << *lci << " ";        // d e f i k

  return 0;
}


